########################################################################
#
#  General configuration
#

Name: sampler
Version: 1.9.2
Release: 1
License: BSD
Group: Applications/System
Packager: Ben Liblit <liblit@cs.wisc.edu>
Vendor: University of Wisconsin-Madison
Distribution: Cooperative Bug Isolation Project
URL: http://research.cs.wisc.edu/cbi/
Source: %name-%version.tar.gz
BuildRoot: %_tmppath/%name-%version-%release-buildroot
BuildRequires: /usr/bin/camlp4o.opt
BuildRequires: binutils
BuildRequires: dbus-devel
BuildRequires: desktop-file-utils
BuildRequires: docbook-style-xsl
BuildRequires: flex
BuildRequires: gcc
BuildRequires: glib2-devel
BuildRequires: gsl-devel
BuildRequires: inkscape
BuildRequires: libuuid-devel
BuildRequires: lttng-ust-devel
BuildRequires: ocaml
BuildRequires: ocaml-cil-devel >= 1.3.6
BuildRequires: perl
BuildRequires: scons
BuildRequires: scrollkeeper

# additional packages required by check scriptlet
BuildRequires: /usr/bin/xmllint
BuildRequires: pychecker


########################################################################
#
#  Package sampler
#

Summary: Support for applications with sampled instrumentation
Requires: gobject-introspection
Requires: gtk3 >= 3.0
Requires: python >= 2.7
Requires: webkitgtk3
Requires(pre): GConf2
Requires(posttrans): glib2 >= 2.25.3
Requires(postun): glib2 >= 2.25.3
%if 0%{?fedora} >= 16
Requires: pygobject3
%else
Requires: pygobject2
%endif
Obsoletes: sampler-gnome < 0.5

%description
This package supports instrumented applications at run time.  It
includes tools for launching instrumented applications, collecting
sample and crash reports, and uploading those reports to the central
bug isolation server.

%pre
%gconf_schema_obsolete %name

%post
/sbin/ldconfig
touch --no-create %_datadir/icons/hicolor &>/dev/null || :
gtk-update-icon-cache --quiet %_datadir/icons/hicolor &>/dev/null || :

%postun
/sbin/ldconfig
if [ "$1" -eq 0 ]; then
  touch --no-create %_datadir/icons/hicolor &>/dev/null
  gtk-update-icon-cache --quiet %_datadir/icons/hicolor &>/dev/null || :
  glib-compile-schemas %_datadir/glib-2.0/schemas &> /dev/null || :
fi

%posttrans
gtk-update-icon-cache --quiet %_datadir/icons/hicolor &>/dev/null || :
glib-compile-schemas %_datadir/glib-2.0/schemas &> /dev/null || :

%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS
%dir %_libdir/%name
%_libdir/%name/sites
%_libdir/%name/wrapped
%dir %_datadir/%name
%_datadir/%name/common
%_datadir/%name/first-time
%_datadir/%name/tray
%_datadir/%name/wrapper
%_datadir/applications/*
%_datadir/dbus-1/services/*
%_datadir/GConf/gsettings/*
%_datadir/glib-2.0/schemas/*
%_datadir/icons/hicolor/*/status/*


########################################################################
#
#  Package sampler-devel
#

%package devel
Group: Development/Tools
Summary: Tools for building applications with sampled instrumentation
Requires: binutils
Requires: gcc
Requires: perl >= 5.8
Requires: %name-libs = %version

%description devel
This package provides tools for building applications with sampled
instrumentation.  It includes an instrumenting C compiler and utility
tools for collecting and decoding sampled instrumentation reports.

%files devel
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS
%_bindir/sampler-cc
%dir %_datadir/%name
%_datadir/%name/doc
%_datadir/omf/*
%_libdir/*.a
%_libdir/*.so
%dir %_libdir/%name
%_libdir/%name/driver
%_libdir/%name/tools
%_sysconfdir/rpm/*


########################################################################
#
#  Package sampler-libs
#

%package libs
Group: Development/Libraries
Summary: Libraries for use with sampled instrumentation

%description libs
This package provides run-time libraries used by applications with
sampled instrumentation.

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files libs
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS
%_libdir/*.so.*


########################################################################
#
#  Package sampler-server
#

%package server
Group: System Environment/Daemons
Summary: CGI script to receive uploaded instrumentation reports
Requires: webserver
Requires: mod_cgi.so
Requires: mod_unique_id.so

%description server
This package provides a CGI script that manages the server end of
sampled instrumentation reporting.  It can be added to any standard
Apache web server installation that supports CGI scripts and the
$UNIQUE_ID environment variable.

%files server
%defattr(-,root,root,-)
%doc AUTHORS COPYING NEWS
%_localstatedir/www/cgi-bin/*
%attr(750,apache,apache) %dir %_localstatedir/www/sampler-uploads


########################################################################
#
#  General scripts
#

%prep
%setup -q

%build
%define scons scons %{?_smp_mflags} OCAML_NATIVE=True extra_cflags='%optflags' prefix='%_prefix'

%scons

%install
%scons GSETTINGS_SCHEMAS_COMPILE=no DESTDIR=%buildroot install
desktop-file-validate %buildroot/%_datadir/applications/first-time.desktop

%check
%scons test
desktop-file-validate %buildroot/%_datadir/applications/first-time.desktop


%changelog
